import React from "react";
import { Context } from "../store";
export const Emitter = ({ onChange, onSelect }) => {
    const { store } = React.useContext(Context);
    const { choosing: pointing, selectingZone: zone, table, tableInitialized, } = store;
    React.useEffect(() => {
        tableInitialized &&
            table &&
            onChange &&
            onChange(table, {
                pointing,
                selectingFrom: { y: zone.startY, x: zone.startX },
                selectingTo: { y: zone.endY, x: zone.endX },
            });
    }, [table]);
    React.useEffect(() => {
        onSelect &&
            onSelect(table, {
                pointing,
                selectingFrom: { y: zone.startY, x: zone.startX },
                selectingTo: { y: zone.endY, x: zone.endX },
            });
    }, [pointing, zone]);
    return React.createElement(React.Fragment, null);
};
//# sourceMappingURL=Emitter.js.map