import React from "react";
import { x2c } from "../lib/converters";
import { between } from "../lib/structs";
import { Context } from "../store";
import { choose, drag, selectCols, setContextMenuPosition, setResizingPositionX, } from "../store/actions";
import { DUMMY_IMG, DEFAULT_WIDTH } from "../constants";
export const HeaderTopCell = React.memo(({ x }) => {
    const { store, dispatch } = React.useContext(Context);
    const colId = x2c(x);
    const { table, choosing, selectingZone, resizingRect, headerTopSelecting, headerHeight, editorRef, autofillDraggingTo, } = store;
    const col = table.getByPoint({ y: 0, x });
    const width = (col === null || col === void 0 ? void 0 : col.width) || DEFAULT_WIDTH;
    return (React.createElement("th", { className: `gs-header gs-header-horizontal gs-header-top ${choosing.x === x ? "gs-choosing" : ""} ${between({ start: selectingZone.startX, end: selectingZone.endX }, x)
            ? headerTopSelecting
                ? "gs-header-selecting"
                : "gs-selecting"
            : ""} ${x === table.getNumCols() ? "gs-header-top-end" : ""}`, style: { width, minWidth: width, maxWidth: width }, onClick: (e) => {
            var _a;
            let startX = e.shiftKey ? selectingZone.startX : x;
            if (startX === -1) {
                startX = choosing.x;
            }
            dispatch(selectCols({
                range: { start: startX, end: x },
                numRows: table.getNumRows(),
            }));
            dispatch(setContextMenuPosition({ y: -1, x: -1 }));
            dispatch(choose({ y: 1, x: startX }));
            (_a = editorRef.current) === null || _a === void 0 ? void 0 : _a.focus();
            return false;
        }, onContextMenu: (e) => {
            e.preventDefault();
            dispatch(setContextMenuPosition({ y: e.clientY, x: e.clientX }));
            return false;
        } },
        React.createElement("div", { className: "gs-header-outer", draggable: true, onDragStart: (e) => {
                e.dataTransfer.setDragImage(DUMMY_IMG, 0, 0);
                dispatch(selectCols({
                    range: { start: x, end: x },
                    numRows: table.getNumRows(),
                }));
                dispatch(choose({ y: 1, x }));
                return false;
            }, onDragEnter: () => {
                if (resizingRect.x === -1 && autofillDraggingTo == null) {
                    const { startY } = selectingZone;
                    if (startY === 1) {
                        dispatch(drag({ y: table.getNumRows(), x }));
                    }
                    else {
                        dispatch(drag({ y: 1, x }));
                    }
                }
                return false;
            }, onDragOver: (e) => {
                e.dataTransfer.dropEffect = "move";
                e.preventDefault();
            } },
            React.createElement("div", { className: "gs-header-inner", style: { height: headerHeight, position: 'relative' } },
                (col === null || col === void 0 ? void 0 : col.labeler) ? table.getLabel(col.labeler, x) : colId,
                React.createElement("div", { className: "gs-resizer", style: { height: headerHeight }, onMouseDown: (e) => {
                        dispatch(setResizingPositionX([x, e.clientX, e.clientX]));
                        e.preventDefault();
                        e.stopPropagation();
                    } },
                    React.createElement("i", null))))));
});
//# sourceMappingURL=HeaderTopCell.js.map