import { FormulaError } from "../evaluator";
import { BaseFunction } from "./__base";
import { ensureNumber } from "./__utils";
export class AbsFunction extends BaseFunction {
    constructor() {
        super(...arguments);
        this.example = "ABS(-2)";
        this.helpText = ["Returns the absolute value of a number"];
        this.helpArgs = [{ name: "value", description: "target number" }];
    }
    validate() {
        if (this.bareArgs.length !== 1) {
            throw new FormulaError("#N/A", "Number of arguments for ABS is incorrect.");
        }
        this.bareArgs = this.bareArgs.map((arg) => ensureNumber(arg));
    }
    main(value) {
        return Math.abs(value);
    }
}
//# sourceMappingURL=abs.js.map