import { BaseFunction } from "./__base";
import { ensureBoolean } from "./__utils";
export class AndFunction extends BaseFunction {
    constructor() {
        super(...arguments);
        this.example = "AND(A1=1, A2=2)";
        this.helpText = [
            "Returns TRUE if all arguments are logically TRUE.",
            "Returns FALSE if any argument is logically FALSE.",
        ];
        this.helpArgs = [
            { name: "expression1", description: "First logical expression." },
            {
                name: "expression2",
                description: "Additional expressions",
                optional: true,
                iterable: true,
            },
        ];
    }
    validate() {
        this.bareArgs = this.bareArgs.map((arg) => ensureBoolean(arg));
    }
    main(...values) {
        return values.reduce((a, b) => a && b);
    }
}
//# sourceMappingURL=and.js.map