import { FormulaError } from "../evaluator";
import { BaseFunction } from "./__base";
import { ensureNumber } from "./__utils";
export class AtanFunction extends BaseFunction {
    constructor() {
        super(...arguments);
        this.example = "ATAN(1)";
        this.helpText = ["Returns the inverse tan of the value in radians."];
        this.helpArgs = [
            {
                name: "value",
                description: "A value for the inverse tan.",
            },
        ];
    }
    validate() {
        if (this.bareArgs.length !== 1) {
            throw new FormulaError("#N/A", "Number of arguments for ATAN is incorrect.");
        }
        this.bareArgs = this.bareArgs.map((arg) => ensureNumber(arg));
    }
    main(value) {
        return Math.atan(value);
    }
}
//# sourceMappingURL=atan.js.map