import { BaseFunction } from "./__base";
import { ensureString } from "./__utils";
export class ConcatenateFunction extends BaseFunction {
    constructor() {
        super(...arguments);
        this.example = 'CONCATENATE("Hello", "World")';
        this.helpText = ["Returns the concatenation of the values."];
        this.helpArgs = [
            { name: "value1", description: "First string value." },
            {
                name: "value2",
                description: "Additional string values to be concatenated with the value1",
                optional: true,
                iterable: true,
            },
        ];
    }
    validate() {
        this.bareArgs = this.bareArgs.map((arg) => ensureString(arg));
    }
    main(...values) {
        return values.reduce((a, b) => a + b);
    }
}
//# sourceMappingURL=concatenate.js.map