import { FormulaError } from "../evaluator";
import { BaseFunction } from "./__base";
export class EqFunction extends BaseFunction {
    constructor() {
        super(...arguments);
        this.example = "EQ(6, 7)";
        this.helpText = [
            "Returns TRUE if the two specified values are equal, FALSE if they are not.",
            "This is the same as the '=' operator.",
        ];
        this.helpArgs = [
            { name: "value1", description: "First value." },
            { name: "value2", description: "A value to be compared with value1." },
        ];
    }
    validate() {
        if (this.bareArgs.length !== 2) {
            throw new FormulaError("#N/A", "Number of arguments for EQ is incorrect.");
        }
    }
    main(v1, v2) {
        return v1 === v2;
    }
}
//# sourceMappingURL=eq.js.map