// DO NOT COPY THIS CODE FOR THE OTHER.
import { FormulaError } from "../evaluator";
import { stripTable } from "./__utils";
export class IfErrorFunction {
    constructor({ args, table }) {
        this.example = 'IFERROR(A1, "Error in cell A1")';
        this.helpText = [
            "Returns the first argument if it is not an error value, otherwise returns the second argument if present, or a blank if the second argument is absent.",
        ];
        this.helpArgs = [
            {
                name: "value",
                description: "The value to return if value itself is not an error.",
            },
            {
                name: "value_if_error",
                description: "The value the function returns if value is an error.",
                optional: true,
            },
        ];
        this.args = args;
        this.table = table;
    }
    validate() {
        if (this.args.length === 1 || this.args.length === 2) {
            return;
        }
        throw new FormulaError("#N/A", "Number of arguments for IFERROR is incorrect. 1 or 2 argument(s) must be specified.");
    }
    call() {
        this.validate();
        const [value, valueIfError] = this.args;
        try {
            return stripTable(value.evaluate({ table: this.table }));
        }
        catch (e) {
            return stripTable(valueIfError === null || valueIfError === void 0 ? void 0 : valueIfError.evaluate({ table: this.table }));
        }
    }
}
//# sourceMappingURL=iferror.js.map