import { FormulaError } from "../evaluator";
import { BaseFunction } from "./__base";
import { ensureString } from "./__utils";
export class LenFunction extends BaseFunction {
    constructor() {
        super(...arguments);
        this.example = "LEN(A2)";
        this.helpText = ["Returns the length of a string."];
        this.helpArgs = [
            {
                name: "text",
                description: "A text to be returned the length.",
            },
        ];
    }
    validate() {
        if (this.bareArgs.length !== 1) {
            throw new FormulaError("#N/A", "Number of arguments for LEN is incorrect.");
        }
        this.bareArgs = [ensureString(this.bareArgs[0])];
    }
    main(text) {
        return text.length;
    }
}
//# sourceMappingURL=len.js.map