import { FormulaError } from "../evaluator";
import { BaseFunction } from "./__base";
export class NowFunction extends BaseFunction {
    constructor() {
        super(...arguments);
        this.example = "NOW()";
        this.helpText = [
            "Returns a serial value corresponding to the current date and time.",
        ];
        this.helpArgs = [];
    }
    validate() {
        if (this.bareArgs.length !== 0) {
            throw new FormulaError("#N/A", "Number of arguments for NOW is incorrect.");
        }
    }
    main() {
        return new Date();
    }
}
//# sourceMappingURL=now.js.map