import { BaseFunction } from "./__base";
import { ensureBoolean } from "./__utils";
export class OrFunction extends BaseFunction {
    constructor() {
        super(...arguments);
        this.example = "OR(A1=1, A2=2)";
        this.helpText = [
            "Returns TRUE if any argument is logically true.",
            "Returns FALSE if all arguments are logically false.",
        ];
        this.helpArgs = [
            { name: "expression1", description: "First logical expression." },
            {
                name: "expression2",
                description: "Additional expressions",
                optional: true,
                iterable: true,
            },
        ];
    }
    validate() {
        this.bareArgs = this.bareArgs.map((arg) => ensureBoolean(arg));
    }
    main(...values) {
        return values.reduce((a, b) => a || b);
    }
}
//# sourceMappingURL=or.js.map