import { FormulaError } from "../evaluator";
import { BaseFunction } from "./__base";
export class RowFunction extends BaseFunction {
    constructor() {
        super(...arguments);
        this.example = "ROW(A9)";
        this.helpText = ["Returns the row number of a specified cell."];
        this.helpArgs = [
            {
                name: "cell_reference",
                description: "The cell whose row number will be returned.",
                option: true,
            },
        ];
    }
    validate() {
        if (this.bareArgs.length === 0) {
            this.bareArgs = [this.table];
        }
        else if (this.bareArgs.length === 1) {
        }
        else {
            throw new FormulaError("#N/A", "Number of arguments for ROW is incorrect.");
        }
    }
    main(trimmed) {
        return trimmed.top;
    }
}
//# sourceMappingURL=row.js.map