import { FormulaError } from "../evaluator";
import { BaseFunction } from "./__base";
import { ensureNumber } from "./__utils";
export class UminusFunction extends BaseFunction {
    constructor() {
        super(...arguments);
        this.example = "UMINUS(4)";
        this.helpText = ["Returns a number with positive and negative values reversed."];
        this.helpArgs = [
            { name: "value1", description: "A number that will be subtracted." },
        ];
    }
    validate() {
        if (this.bareArgs.length !== 1) {
            throw new FormulaError("#N/A", "A single numerical value is only required.");
        }
        this.bareArgs = this.bareArgs.map((arg) => ensureNumber(arg));
    }
    main(v1) {
        return -v1;
    }
}
//# sourceMappingURL=uminus.js.map