import { addYears, addMonths, addDays, addHours, addMinutes, addSeconds, addMilliseconds, subYears, subMonths, subDays, subHours, subMinutes, subSeconds, subMilliseconds, } from 'date-fns';
export const BASE_DATE = new Date('2345-01-02T03:04:05Z');
const ADD_FNS = [addYears, addMonths, addDays, addHours, addMinutes, addSeconds, addMilliseconds];
const SUB_FNS = [subYears, subMonths, subDays, subHours, subMinutes, subSeconds, subMilliseconds];
export class TimeDelta {
    constructor(date1, date2) {
        this.diff = [0, 0, 0, 0, 0, 0, 0];
        this.diff = [
            (date1.getFullYear() - date2.getFullYear()),
            (date1.getMonth() - date2.getMonth()),
            (date1.getDate() - date2.getDate()),
            (date1.getHours() - date2.getHours()),
            (date1.getMinutes() - date2.getMinutes()),
            (date1.getSeconds() - date2.getSeconds()),
            (date1.getMilliseconds() - date2.getMilliseconds()),
        ];
        this.date1 = date1;
        this.date2 = date2;
    }
    add(date) {
        this.diff.forEach((n, i) => {
            date = ADD_FNS[i](date, n);
        });
        return date;
    }
    sub(date) {
        this.diff.forEach((n, i) => {
            date = SUB_FNS[i](date, n);
        });
        return date;
    }
    stringify(format = "HH:mm") {
        const tokens = [];
        const msecs = this.date1.getMilliseconds() - this.date2.getMilliseconds();
        let secs = (this.date1.getTime() - this.date2.getTime()) / 1000;
        for (const divider of [3600, 60]) {
            tokens.push(Math.floor(secs / divider));
            secs %= divider;
        }
        tokens.push(secs, msecs);
        let result = format;
        result = result.replace("HH", String(tokens[0]).padStart(2, '0'));
        result = result.replace("H", String(tokens[0]));
        result = result.replace("mm", String(tokens[1]).padStart(2, '0'));
        result = result.replace("ss", String(tokens[2]).padStart(2, '0'));
        result = result.replace("SSS", String(tokens[3]).padStart(3, '0'));
        result = result.replace("SS", String(tokens[3]).padStart(2, '0').substring(0, 2));
        result = result.replace("S", String(tokens[3]).padStart(1, '0').substring(0, 1));
        return result;
    }
    static create(hours = 0, minutes = 0, seconds = 0, milliseconds = 0) {
        const diff = [0, 0, 0, hours, minutes, seconds, milliseconds];
        let date = BASE_DATE;
        diff.forEach((n, i) => {
            date = ADD_FNS[i](date, n);
        });
        return new TimeDelta(date, BASE_DATE);
    }
}
//# sourceMappingURL=time.js.map