import { CellType } from "../types";
import { TimeDelta } from "../lib/time";
declare type Condition = (value: string) => boolean;
declare type Stringify = (value: string) => any;
declare type Props = {
    condition?: Condition;
    complement?: Stringify;
    mixins?: ParserMixinType[];
};
export interface ParserMixinType {
    parseFunctions?: ((value: string, cell: CellType) => any)[];
    parse?(value: string, cell: CellType): CellType;
    callback?(parsed: any, cell: CellType): any;
    bool?(value: string, cell: CellType): boolean | undefined;
    number?(value: string, cell: CellType): number | undefined;
    timedelta?(value: string, cell: CellType): TimeDelta | undefined;
    date?(value: string, cell: CellType): Date | undefined;
}
export declare class Parser implements ParserMixinType {
    parseFunctions: ((value: string, cell: CellType) => any)[];
    private condition?;
    private complement?;
    constructor(props?: Props);
    private applyMixins;
    callback(parsed: any, cell: CellType): any;
    parse(value: string, cell: CellType): CellType;
    protected _parse(value: string, cell: CellType): any;
    bool(value: string, cell: CellType): boolean | undefined;
    number(value: string, cell: CellType): number | undefined;
    timedelta(value: string, cell: CellType): TimeDelta | undefined;
    date(value: string, cell: CellType): Date | undefined;
}
export declare type ParserType = Parser;
export declare const defaultParser: Parser;
export {};
//# sourceMappingURL=core.d.ts.map