import { CellType, PointType, WriterType } from "../types";
import { Table, UserTable } from "../lib/table";
import { TimeDelta } from "../lib/time";
declare type Condition = (value: any) => boolean;
declare type Stringify = (value: any) => string;
declare type Props = {
    condition?: Condition;
    complement?: Stringify;
    mixins?: RendererMixinType[];
};
export interface RendererMixinType {
    render?(table: UserTable, point: PointType, writer?: WriterType): any;
    stringify?(cell: CellType): string;
    string?(value: string, table: UserTable, writer?: WriterType): any;
    bool?(value: boolean, writer?: WriterType): any;
    number?(value: number, writer?: WriterType): any;
    date?(value: Date, writer?: WriterType): any;
    timedelta?(value: TimeDelta, writer?: WriterType): any;
    array?(value: any[], writer?: WriterType): any;
    object?(value: any, writer?: WriterType): any;
    null?(value: null, writer?: WriterType): any;
    undefined?(value: undefined, writer?: WriterType): any;
}
export declare class Renderer implements RendererMixinType {
    datetimeFormat: string;
    dateFormat: string;
    timeDeltaFormat: string;
    private condition?;
    private complement?;
    constructor(props?: Props);
    private applyMixins;
    render(table: Table, point: PointType, writer?: WriterType): any;
    _render(value: any, table: Table, writer?: WriterType): any;
    stringify(cell: CellType): string;
    string(value: string, table: Table, writer?: WriterType): any;
    bool(value: boolean, writer?: WriterType): any;
    number(value: number, writer?: WriterType): any;
    date(value: Date, writer?: WriterType): any;
    timedelta(value: TimeDelta, writer?: WriterType): any;
    array(value: any[], writer?: WriterType): any;
    object(value: any, writer?: WriterType): any;
    null(value: null, writer?: WriterType): any;
    undefined(value: undefined, writer?: WriterType): any;
}
export declare type RendererType = Renderer;
export declare const defaultRenderer: Renderer;
export {};
//# sourceMappingURL=core.d.ts.map