import { StoreType, RectType, ZoneType, PointType, RangeType, FeedbackType, PositionType } from "../types";
import { Table } from "../lib/table";
export declare const reducer: <T>(store: StoreType, action: {
    type: number;
    value: T;
}) => StoreType;
export declare class CoreAction<T> {
    static head: number;
    private actionId;
    reduce(store: StoreType, payload: T): StoreType;
    call(payload: T): {
        type: number;
        value: T;
    };
    bind(): (payload: T) => {
        type: number;
        value: T;
    };
}
export declare const setSearchQuery: (payload: string | undefined) => {
    type: number;
    value: string | undefined;
};
export declare const setEditingCell: (payload: string) => {
    type: number;
    value: string;
};
export declare const setEditingOnEnter: (payload: boolean) => {
    type: number;
    value: boolean;
};
export declare const setAutofillDraggingTo: (payload: PointType | null) => {
    type: number;
    value: PointType | null;
};
export declare const setShowAddress: (payload: boolean) => {
    type: number;
    value: boolean;
};
export declare const setContextMenuPosition: (payload: PositionType) => {
    type: number;
    value: PositionType;
};
export declare const setResizingPositionY: (payload: [number, number, number]) => {
    type: number;
    value: [number, number, number];
};
export declare const setResizingPositionX: (payload: [number, number, number]) => {
    type: number;
    value: [number, number, number];
};
export declare const setOnSave: (payload: FeedbackType) => {
    type: number;
    value: FeedbackType;
};
export declare const setEntering: (payload: boolean) => {
    type: number;
    value: boolean;
};
export declare const setHeaderHeight: (payload: number) => {
    type: number;
    value: number;
};
export declare const setHeaderWidth: (payload: number) => {
    type: number;
    value: number;
};
export declare const setSheetHeight: (payload: number) => {
    type: number;
    value: number;
};
export declare const setSheetWidth: (payload: number) => {
    type: number;
    value: number;
};
export declare const initializeTable: (payload: Table) => {
    type: number;
    value: Table;
};
export declare const updateTable: (payload: Table) => {
    type: number;
    value: Table;
};
export declare const setEditorRect: (payload: RectType) => {
    type: number;
    value: RectType;
};
export declare const setResizingRect: (payload: RectType) => {
    type: number;
    value: RectType;
};
export declare const blur: (payload: null) => {
    type: number;
    value: null;
};
export declare const copy: (payload: ZoneType) => {
    type: number;
    value: ZoneType;
};
export declare const cut: (payload: ZoneType) => {
    type: number;
    value: ZoneType;
};
export declare const paste: (payload: {
    text: string;
}) => {
    type: number;
    value: {
        text: string;
    };
};
export declare const escape: (payload: null) => {
    type: number;
    value: null;
};
export declare const choose: (payload: PointType) => {
    type: number;
    value: PointType;
};
export declare const select: (payload: ZoneType) => {
    type: number;
    value: ZoneType;
};
export declare const selectRows: (payload: {
    range: RangeType;
    numCols: number;
}) => {
    type: number;
    value: {
        range: RangeType;
        numCols: number;
    };
};
export declare const selectCols: (payload: {
    range: RangeType;
    numRows: number;
}) => {
    type: number;
    value: {
        range: RangeType;
        numRows: number;
    };
};
export declare const drag: (payload: PointType) => {
    type: number;
    value: PointType;
};
export declare const search: (payload: number) => {
    type: number;
    value: number;
};
export declare const write: (payload: string) => {
    type: number;
    value: string;
};
export declare const clear: (payload: null) => {
    type: number;
    value: null;
};
export declare const undo: (payload: null) => {
    type: number;
    value: null;
};
export declare const redo: (payload: null) => {
    type: number;
    value: null;
};
export declare const arrow: (payload: {
    shiftKey: boolean;
    deltaY: number;
    deltaX: number;
    numRows: number;
    numCols: number;
}) => {
    type: number;
    value: {
        shiftKey: boolean;
        deltaY: number;
        deltaX: number;
        numRows: number;
        numCols: number;
    };
};
export declare const walk: (payload: {
    deltaY: number;
    deltaX: number;
    numRows: number;
    numCols: number;
}) => {
    type: number;
    value: {
        deltaY: number;
        deltaX: number;
        numRows: number;
        numCols: number;
    };
};
//# sourceMappingURL=actions.d.ts.map